// devquery.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#using <mscorlib.dll>
using namespace System;
using namespace System::Threading;
using namespace NationalInstruments::VisaNS;

int _tmain(int argc, _TCHAR* argv[])
{
	MessageBasedSession^ mbSession;
	String^ s;
	String^ ret;
	int cnt = 0;

	Console::WriteLine("\n ###########   Start Visual Studio 2005 Visual C++ Example   ###########");
	Console::WriteLine(" This Example check the Multimeter M3500A On USB port and");
	Console::WriteLine(" identify the ALL connected DMM device, configure the DMM functions.\n");

	try
	{
		cnt = ResourceManager::GetLocalManager()->FindResources("USB0::0x164E::0x0DAD::?*")->Length;
	}
	catch ( Exception^ ex)
	{
		Console::WriteLine("Device not found. {0}", ex->Message );
		return 0;
	}
				
	array<String^>^ resrc = ResourceManager::GetLocalManager()->FindResources("USB0::0x164E::0x0DAD::?*");
				
	for (int i=0; i<resrc->Length ; i++)
	{
		s = resrc[i];
		mbSession = (MessageBasedSession^)(ResourceManager::GetLocalManager()->Open(s)); 
        //
        // Send command "*idn?" and read the identification string
		mbSession->Write("*idn?");
		Thread::Sleep(200);
		Console::WriteLine(" Query *idn? :");
		ret = mbSession->ReadString();
		Console::WriteLine(" --> {0}", ret);
        //
        // Set the sample count to 1
        mbSession->Write("SAMP:COUN 1");
		Console::WriteLine(" --> Set the sample count = 1");
		Thread::Sleep(1000);
        // Set configure function VOLTage AC, range 10
		mbSession->Write("CONF:VOLT:AC 10,0.01");
		Console::WriteLine(" --> Set the configure function VOLTage AC, range 0.1");
		Thread::Sleep(2000);
        // Set configure function FREQuency
		mbSession->Write("CONF:FREQ");
		Console::WriteLine(" --> Set the configure function FREQuency");
		Thread::Sleep(2000);
        // Set configure function CURRent DC, range 1
		mbSession->Write("CONF:CURR:DC 0.1,0.01");
		Console::WriteLine(" --> Set the configure function CURRent DC, range 1");
		Thread::Sleep(1000);
        // Set configure function VOLTage DC, range 0.1
        mbSession->Write("CONF:VOLT:DC 1,0.1");
		Console::WriteLine(" --> Set the configure function VOLTage DC, range 0.1");
		Thread::Sleep(1000);
        // Read the measurement
        mbSession->Write("read?");
		Thread::Sleep(200);
        ret = mbSession->ReadString();
		Console::WriteLine(" Read in the measurement :");
		Console::WriteLine(" --> " + ret);

        // Set the M3500A to local mode
		mbSession->Write("system:local");
	}

	Console::Write ("\n Press any key to exit ... ");
	Console::ReadKey();
	return 0;
}

